searchNodes=[{"ref":"Switch.html","title":"Switch","type":"module","doc":""},{"ref":"Switch.html#callback_mode/0","title":"Switch.callback_mode/0","type":"function","doc":""},{"ref":"Switch.html#child_spec/1","title":"Switch.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor in Elixir v1.6+."},{"ref":"Switch.html#flip/1","title":"Switch.flip/1","type":"function","doc":""},{"ref":"Switch.html#get_count/1","title":"Switch.get_count/1","type":"function","doc":""},{"ref":"Switch.html#start_link/0","title":"Switch.start_link/0","type":"function","doc":""},{"ref":"Xxo.html","title":"Xxo","type":"module","doc":"Documentation for Xxo."},{"ref":"Xxo.html#new_game/1","title":"Xxo.new_game/1","type":"function","doc":"Generates a new game under supervision"},{"ref":"Xxo.AI.html","title":"Xxo.AI","type":"module","doc":"The Artificial Intelligence module for single player mode"},{"ref":"Xxo.AI.html#calculate_move/2","title":"Xxo.AI.calculate_move/2","type":"function","doc":""},{"ref":"Xxo.Game.html","title":"Xxo.Game","type":"module","doc":"The Game module"},{"ref":"Xxo.GameServer.html","title":"Xxo.GameServer","type":"module","doc":"The Game module is responsible for starting/stopping new games."},{"ref":"Xxo.GameServer.html#child_spec/1","title":"Xxo.GameServer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xxo.GameServer.html#computer_move/2","title":"Xxo.GameServer.computer_move/2","type":"function","doc":""},{"ref":"Xxo.GameServer.html#get_state/1","title":"Xxo.GameServer.get_state/1","type":"function","doc":""},{"ref":"Xxo.GameServer.html#player_move/3","title":"Xxo.GameServer.player_move/3","type":"function","doc":""},{"ref":"Xxo.GameServer.html#reset_state/1","title":"Xxo.GameServer.reset_state/1","type":"function","doc":""},{"ref":"Xxo.GameServer.html#start_link/1","title":"Xxo.GameServer.start_link/1","type":"function","doc":""},{"ref":"Xxo.GameServer.html#stop/1","title":"Xxo.GameServer.stop/1","type":"function","doc":""},{"ref":"Xxo.GameServer.html#whereis/1","title":"Xxo.GameServer.whereis/1","type":"function","doc":"Returns the pid for the game_name stored in the registry"},{"ref":"Xxo.GameSupervisor.html","title":"Xxo.GameSupervisor","type":"module","doc":"The Game Supervisor, a dynamic supervisor providing fault tolerance"},{"ref":"Xxo.GameSupervisor.html#child_spec/1","title":"Xxo.GameSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xxo.GameSupervisor.html#children/0","title":"Xxo.GameSupervisor.children/0","type":"function","doc":"Check which processes are under supervision"},{"ref":"Xxo.GameSupervisor.html#count_children/0","title":"Xxo.GameSupervisor.count_children/0","type":"function","doc":"Check how many processes are under supervision"},{"ref":"Xxo.GameSupervisor.html#create_game/1","title":"Xxo.GameSupervisor.create_game/1","type":"function","doc":""},{"ref":"Xxo.GameSupervisor.html#remove_game/1","title":"Xxo.GameSupervisor.remove_game/1","type":"function","doc":""},{"ref":"Xxo.GameSupervisor.html#start_link/1","title":"Xxo.GameSupervisor.start_link/1","type":"function","doc":""},{"ref":"Xxo.State.html","title":"Xxo.State","type":"module","doc":"This module is used to track game state and declare when a user has won/lost."},{"ref":"Xxo.State.html#next_player/1","title":"Xxo.State.next_player/1","type":"function","doc":"Returns the next player to move"},{"ref":"Xxo.State.html#winner?/2","title":"Xxo.State.winner?/2","type":"function","doc":"Checks if there are 3 symbols in a row"},{"ref":"readme.html","title":"xxo","type":"extras","doc":"xxo A tic-tac-toe game engine written in Elixir. This is an MVP. My intention is to build a working product and then improve upon it on each iteration."},{"ref":"readme.html#version-1","title":"xxo - Version 1","type":"extras","doc":"The first version will consist of a single player mode."},{"ref":"readme.html#version-2","title":"xxo - Version 2","type":"extras","doc":"The second version of the game will add a two-player mode. Users will gain the ability to play against a choosen or random opponent."},{"ref":"readme.html#version-3","title":"xxo - Version 3","type":"extras","doc":"The third version of the game will include an option for choosing the difficulty level of the computer. A single player will choose between easy, average, and hard modes."},{"ref":"readme.html#installation","title":"xxo - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding xxo to your list of dependencies in mix.exs: def deps do [ {:xxo, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/xxo. Xxo is a game engine for tic-tac-toe. While it is possible to play the game entirely from the command line the recommended method of play is using xxo_ui, a Phoenix application that provides a user-friendly front-end."},{"ref":"readme.html#after-installation","title":"xxo - After Installation","type":"extras","doc":"Start a new game by calling Xxo.new_game(&quot;name&quot;), where &quot;name&quot; is the name of the player initiating the game. This call will return {:ok, pid}, where pid is the process id of the game. You can verify the game has started successfully by calling Xxo.GameSupervisor.children(), which will return the details of the current games under supervision. Retrieve the current state of the game by calling Xxo.GameServer.get_state(&quot;name&quot;), passing in the same name that was used to start the game. This will return a struct that includes the following: %Xxo.Game{ action_on: &quot;mia&quot;, board: %{ {0, 0} =&gt; &quot; &quot;, {0, 1} =&gt; &quot;x&quot;, {0, 2} =&gt; &quot; &quot;, {1, 0} =&gt; &quot; &quot;, {1, 1} =&gt; &quot; &quot;, {1, 2} =&gt; &quot; &quot;, {2, 0} =&gt; &quot; &quot;, {2, 1} =&gt; &quot; &quot;, {2, 2} =&gt; &quot; &quot; }, finished: false, game_name: &quot;mia&quot;, winner: nil } Here is an example game played with version 1: iex(4)&gt; Xxo.new_game(&quot;mia&quot;) 16:18:54.214 [info] Process created... Game name: mia {:ok, #PID&lt;0.209.0&gt;} iex(5)&gt; GameServer.player_move(&quot;mia&quot;, &quot;x&quot;, {0, 0}) 16:19:15.130 [info] Player x has made a move. Check game status {:ok, %Xxo.Game{ action_on: &quot;computer&quot;, board: %{ {0, 0} =&gt; &quot;x&quot;, {0, 1} =&gt; &quot; &quot;, {0, 2} =&gt; &quot; &quot;, {1, 0} =&gt; &quot; &quot;, {1, 1} =&gt; &quot; &quot;, {1, 2} =&gt; &quot; &quot;, {2, 0} =&gt; &quot; &quot;, {2, 1} =&gt; &quot; &quot;, {2, 2} =&gt; &quot; &quot; }, finished: false, game_name: &quot;mia&quot;, winner: nil }} iex(6)&gt; GameServer.computer_move(&quot;mia&quot;, &quot;o&quot;) 16:23:18.698 [info] Player o has made a move. Check game status {:ok, %Xxo.Game{ action_on: &quot;computer&quot;, board: %{ {0, 0} =&gt; &quot;x&quot;, {0, 1} =&gt; &quot;o&quot;, {0, 2} =&gt; &quot; &quot;, {1, 0} =&gt; &quot; &quot;, {1, 1} =&gt; &quot; &quot;, {1, 2} =&gt; &quot; &quot;, {2, 0} =&gt; &quot; &quot;, {2, 1} =&gt; &quot; &quot;, {2, 2} =&gt; &quot; &quot; }, finished: false, game_name: &quot;mia&quot;, winner: nil }} iex(7)&gt; GameServer.player_move(&quot;mia&quot;, &quot;x&quot;, {1, 1}) 16:25:11.176 [info] Player x has made a move. Check game status {:ok, %Xxo.Game{ action_on: &quot;computer&quot;, board: %{ {0, 0} =&gt; &quot;x&quot;, {0, 1} =&gt; &quot;o&quot;, {0, 2} =&gt; &quot; &quot;, {1, 0} =&gt; &quot; &quot;, {1, 1} =&gt; &quot;x&quot;, {1, 2} =&gt; &quot; &quot;, {2, 0} =&gt; &quot; &quot;, {2, 1} =&gt; &quot; &quot;, {2, 2} =&gt; &quot; &quot; }, finished: false, game_name: &quot;mia&quot;, winner: nil }} iex(8)&gt; GameServer.computer_move(mia, &quot;o&quot;) ** (CompileError) iex:8: undefined function mia/0 (stdlib) lists.erl:1354: :lists.mapfoldl/3 iex(8)&gt; GameServer.computer_move(&quot;mia&quot;, &quot;o&quot;) 16:25:59.249 [info] Player o has made a move. Check game status {:ok, %Xxo.Game{ action_on: &quot;computer&quot;, board: %{ {0, 0} =&gt; &quot;x&quot;, {0, 1} =&gt; &quot;o&quot;, {0, 2} =&gt; &quot;o&quot;, {1, 0} =&gt; &quot; &quot;, {1, 1} =&gt; &quot;x&quot;, {1, 2} =&gt; &quot; &quot;, {2, 0} =&gt; &quot; &quot;, {2, 1} =&gt; &quot; &quot;, {2, 2} =&gt; &quot; &quot; }, finished: false, game_name: &quot;mia&quot;, winner: nil }} iex(9)&gt; GameServer.player_move(&quot;mia&quot;, &quot;x&quot;, {2, 2}) 16:28:06.770 [info] Player x has made a move. Check game status {:game_over, &quot;x won&quot;}"}]